using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Sample2
{
    public partial class Form1 : Form
    {
        private int TrendSample;
        private Random rnd = new Random();

        public Form1()
        {
            InitializeComponent();

            // Add the following code after the call to InitializeComponent
            const int myNumSamples = 3600;

            Font myFont = new Font("Arial", 16, FontStyle.Bold | FontStyle.Italic);

            //button1.Top = 42;
            //button1.Left = 220;
            button1.Width = 50;
            button1.Height = 25;

            //button2.Top = 42;
            //button2.Left = button1.Left + button1.Width;
            button2.Width = 50;
            button2.Height = 25;

            button1.Text = "Start";
            button2.Text = "Stop";

            button1.BringToFront();
            button2.BringToFront();

            radioButton1.Text = "100ms";
            radioButton2.Text = "1000ms";

            // Configure XY Chart NET control
            XYChartNETCtl1.NumProfiles = 3;
            XYChartNETCtl1.NumXScales = 1;
            XYChartNETCtl1.NumYScales = 1;

            XYChartNETCtl1.Title.Label = "Simple Trending";
            XYChartNETCtl1.Title.Font = myFont;
            XYChartNETCtl1.Title.Color = Color.White;

            XYChartNETCtl1.Trend.Enable = true;
            XYChartNETCtl1.Trend.DisplayLength = 60;

            // Legend
            XYChartNETCtl1.Legend.Visible = true;
            XYChartNETCtl1.Legend.BorderVisible = false;
            XYChartNETCtl1.Legend.YScaleVisible = false;

            // Gradient
            XYChartNETCtl1.Gradient.GradientOption = XYChartNet.XYChartNETCtl.GradientOptions.goCustom;
            XYChartNETCtl1.Gradient.StartColor = Color.LightSteelBlue;
            XYChartNETCtl1.Gradient.EndColor = Color.RoyalBlue;
            XYChartNETCtl1.Gradient.Orientation = XYChartNet.XYChartNETCtl.OrientationOptions.ooVertical;

            // Plot formatting
            XYChartNETCtl1.Plot.Transparent = true;
            XYChartNETCtl1.Plot.Border.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loNone;

            // Toolbar
            XYChartNETCtl1.Toolbar.Visible = true;
            XYChartNETCtl1.Toolbar.BackColor = Color.LightSteelBlue;
            XYChartNETCtl1.Toolbar.Dock = XYChartNet.XYChartNETCtl.PositionOptions.poTop;

            // Crosshairs
            XYChartNETCtl1.Crosshairs.YCoordInLegend = true;
            XYChartNETCtl1.Crosshairs.Color = Color.Green;
            XYChartNETCtl1.Crosshairs.Width = XYChartNet.XYChartNETCtl.WidthOptions.woThreePoint;
            XYChartNETCtl1.Crosshairs.CoordsBackcolor = Color.Green;
            XYChartNETCtl1.Crosshairs.HorizontalVisible = false;
            XYChartNETCtl1.Crosshairs.VerticalVisible = true;

            // X Axis Grid & Scale properties
            XYChartNet.XYChartNETCtl.C_XSCALEPROP xAxis;
            xAxis = XYChartNETCtl1.get_XAxis(0);
            xAxis.Grid.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
            xAxis.Grid.LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid;
            xAxis.Grid.LineColor = Color.Green;
            xAxis.Scale.Label = "";
            xAxis.Scale.TicksColor = Color.White;
            xAxis.Scale.ScaleMode = XYChartNet.XYChartNETCtl.ScaleModes.smAuto;

            // Y Axis Grid & Scale properties
            XYChartNet.XYChartNETCtl.C_YSCALEPROP yAxis;
            yAxis = XYChartNETCtl1.get_YAxis(0);
            yAxis.Grid.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
            yAxis.Grid.LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid;
            yAxis.Grid.LineColor = Color.Green;
            yAxis.Scale.Label = "";
            yAxis.Scale.LabelColor = Color.White;
            yAxis.Scale.TicksColor = Color.White;
            yAxis.Scale.ScaleMode = XYChartNet.XYChartNETCtl.ScaleModes.smManual;
            yAxis.Scale.ScaleManualMin = 0;
            yAxis.Scale.ScaleManualMax = 100;

            XYChartNet.XYChartNETCtl.C_Profile profile;

            // Profile 0
            profile = XYChartNETCtl1.get_Profile(0);
            profile.YScale = 0;
            profile.Label = "Random 0";
            profile.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
            profile.LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woOnePoint;
            profile.LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid;
            profile.LineColor = Color.Red;
            profile.MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone;
            profile.NumSamples = myNumSamples;

            // Profile 1
            profile = XYChartNETCtl1.get_Profile(1);
            profile.YScale = 0;
            profile.Label = "Random 1";
            profile.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
            profile.LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woOnePoint;
            profile.LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid;
            profile.LineColor = Color.Blue;
            profile.MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone;
            profile.NumSamples = myNumSamples;

            // Profile 2
            profile = XYChartNETCtl1.get_Profile(2);
            profile.YScale = 0;
            profile.Label = "Random 2";
            profile.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
            profile.LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woOnePoint;
            profile.LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid;
            profile.LineColor = Color.Yellow;
            profile.MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone;
            profile.NumSamples = myNumSamples;

            XYChartNETCtl1.ClearChartData();

            XYChartNETCtl1.Refresh();

            // Start timer
            timer1.Interval = 100;
            timer1.Enabled = true;
            radioButton1.Checked = true;

        }

        // Timer Event
        private void timer1_Tick(object sender, System.EventArgs e)
        {
            double[,] NewData = new double[1, 6];

            NewData[0, 0] = TrendSample;
            NewData[0, 1] = 30 * rnd.NextDouble() + 70;
            NewData[0, 2] = TrendSample;
            NewData[0, 3] = 30 * rnd.NextDouble() + 40;
            NewData[0, 4] = TrendSample;
            NewData[0, 5] = 30 * rnd.NextDouble() + 10;

            // Add new trend data to chart array
            XYChartNETCtl1.Trend.AddData(1, NewData, XYChartNet.XYChartNETCtl.AppendOpts.aoAppendToEnd);
            XYChartNETCtl1.Refresh();

            TrendSample += 1;
        }


        // Start Trending
        private void button1_Click(object sender, System.EventArgs e)
        {
            timer1.Enabled = true;

            XYChartNETCtl1.Trend.Enable = true;
            XYChartNETCtl1.Refresh();
        }

        // Stop Trending
        private void button2_Click(object sender, System.EventArgs e)
        {
            timer1.Enabled = false;

            XYChartNETCtl1.Trend.Enable = false;
            XYChartNETCtl1.Refresh();
        }

        private void radioButton1_Click(object sender, System.EventArgs e)
        {
            timer1.Interval  = 100;
        }

        private void radioButton2_Click(object sender, System.EventArgs e)
        {
            timer1.Interval = 1000;
        }

    }
}