Public Class Form1

    Private ChartData(,) As Double

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim myTitleFont As New Font("Arial", 16, FontStyle.Italic Or FontStyle.Bold)
        Dim my14Font As New Font("Arial", 14, FontStyle.Bold)
        Dim my10Font As New Font("Arial", 10, FontStyle.Bold)
        Dim my8Font As New Font("Arial", 8, FontStyle.Bold)

        Const NUM_SAMPLES As Integer = 10

        ' Configure XY Chart NET control
        With XyChartNETCtl1
            .Dock = DockStyle.Fill

            .NumProfiles = 10
            .NumXScales = 1
            .NumYScales = 10

            .Title.Label = "Y Stacking Extreme with Linear & Log Scales"
            .Title.Font = myTitleFont
            .Title.Color = Color.White

            ' Gradient Background
            .Gradient.GradientOption = XYChartNet.XYChartNETCtl.GradientOptions.goCustom
            .Gradient.StartColor = Color.LightSteelBlue
            .Gradient.EndColor = Color.FromArgb(211, 222, 237)
            .Gradient.Orientation = XYChartNet.XYChartNETCtl.OrientationOptions.ooVertical

            ' Chart & plot formatting
            .Plot.BackColor = Color.Transparent
            .Plot.Border.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loNone

            ' Toolbar
            .Toolbar.Visible = True
            .Toolbar.BackColor = Color.LightSteelBlue

            ' Format Legend
            .Legend.Visible = True
            .Legend.BorderVisible = True
            .Legend.YScaleVisible = False

            ' Scrollbars
            .Scrollbars.HorizontalVisible = False
            .Scrollbars.VerticalVisible = False

            ' Crosshairs
            .Crosshairs.YCoordInLegend = True
            .Crosshairs.Color = Color.Yellow
            .Crosshairs.Width = XYChartNet.XYChartNETCtl.WidthOptions.woTwoPoint
            .Crosshairs.HorizontalVisible = False
            .Crosshairs.CoordsBackcolor = Color.Yellow

            ' Zoom Window
            .ZoomWindowColor = Color.Yellow

            ' Y Stacking
            .YStacking = True
            .NumYStacks = 3
            .YStack(0).HeightPercentage = 33
            .YStack(1).HeightPercentage = 33
            .YStack(2).HeightPercentage = 33
            .YStack(0).NumYScales = 4
            .YStack(1).NumYScales = 3
            .YStack(2).NumYScales = 3

            ' X Axis
            With .XAxis(0)
                With .Grid
                    .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                    .LineColor = Color.Black
                End With
                With .Scale
                    .Visible = True
                    .Label = "X0Description"
                    .LabelFont = my8Font
                    .LabelColor = Color.Black
                    .TicksColor = Color.Black
                    .TicksFont = my10Font
                End With
            End With

            ' Y Axes
            With .YAxis(0)
                With .Grid
                    .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                    .LineColor = Color.Green
                End With
                With .Scale
                    .Visible = True
                    .Position = XYChartNet.XYChartNETCtl.ScalePositionOptions.spLeftOrBottom
                    .LabelVertical = "Y0Description"
                    .LabelVerticalFont = my8Font
                    .LabelVerticalColor = Color.Green
                    .Label = "Y0Units"
                    .LabelColor = Color.Green
                    .LabelFont = my8Font
                    .TicksColor = Color.Green
                    .TicksFont = my10Font
                End With
            End With
            With .YAxis(1)
                With .Grid
                    .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                    .LineColor = Color.Maroon
                End With
                With .Scale
                    .ScaleType = XYChartNet.XYChartNETCtl.ScaleTypes.stLog
                    .Visible = True
                    .Position = XYChartNet.XYChartNETCtl.ScalePositionOptions.spRightOrTop
                    .LabelVertical = "Y1Description"
                    .LabelVerticalFont = my8Font
                    .LabelVerticalColor = Color.Maroon
                    .Label = "Y1Units"
                    .LabelFont = my8Font
                    .LabelColor = Color.Maroon
                    .TicksColor = Color.Maroon
                    .TicksFont = my10Font
                End With
            End With
            With .YAxis(2)
                With .Grid
                    .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                    .LineColor = Color.Green
                End With
                With .Scale
                    .Visible = True
                    .Position = XYChartNet.XYChartNETCtl.ScalePositionOptions.spLeftOrBottom
                    .LabelVertical = "Y2Description"
                    .LabelVerticalFont = my8Font
                    .LabelVerticalColor = Color.Green
                    .Label = "Y2Units"
                    .LabelFont = my8Font
                    .LabelColor = Color.Green
                    .TicksColor = Color.Green
                    .TicksFont = my10Font
                End With
            End With
            With .YAxis(3)
                With .Grid
                    .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                    .LineColor = Color.Maroon
                End With
                With .Scale
                    .ScaleType = XYChartNet.XYChartNETCtl.ScaleTypes.stLog
                    .Visible = True
                    .Position = XYChartNet.XYChartNETCtl.ScalePositionOptions.spRightOrTop
                    .LabelVertical = "Y3Description"
                    .LabelVerticalFont = my8Font
                    .LabelVerticalColor = Color.Maroon
                    .Label = "Y3Units"
                    .LabelFont = my8Font
                    .LabelColor = Color.Maroon
                    .TicksColor = Color.Maroon
                    .TicksFont = my10Font
                End With
            End With
            With .YAxis(4)
                With .Grid
                    .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                    .LineColor = Color.Green
                End With
                With .Scale
                    .Visible = True
                    .Position = XYChartNet.XYChartNETCtl.ScalePositionOptions.spLeftOrBottom
                    .LabelVertical = "Y4Description"
                    .LabelVerticalFont = my8Font
                    .LabelVerticalColor = Color.Green
                    .Label = "Y4Units"
                    .LabelFont = my8Font
                    .LabelColor = Color.Green
                    .TicksColor = Color.Green
                    .TicksFont = my10Font
                End With
            End With
            With .YAxis(5)
                With .Grid
                    .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                    .LineColor = Color.Maroon
                End With
                With .Scale
                    .ScaleType = XYChartNet.XYChartNETCtl.ScaleTypes.stLog
                    .Visible = True
                    .Position = XYChartNet.XYChartNETCtl.ScalePositionOptions.spRightOrTop
                    .LabelVertical = "Y5Description"
                    .LabelVerticalFont = my8Font
                    .LabelVerticalColor = Color.Maroon
                    .Label = "Y5Units"
                    .LabelFont = my8Font
                    .LabelColor = Color.Maroon
                    .TicksColor = Color.Maroon
                    .TicksFont = my10Font
                End With
            End With
            With .YAxis(6)
                With .Grid
                    .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                    .LineColor = Color.Maroon
                End With
                With .Scale
                    .ScaleType = XYChartNet.XYChartNETCtl.ScaleTypes.stLog
                    .Visible = True
                    .Position = XYChartNet.XYChartNETCtl.ScalePositionOptions.spRightOrTop
                    .LabelVertical = "Y6Description"
                    .LabelVerticalFont = my8Font
                    .LabelVerticalColor = Color.Maroon
                    .Label = "Y6Units"
                    .LabelFont = my8Font
                    .LabelColor = Color.Maroon
                    .TicksColor = Color.Maroon
                    .TicksFont = my10Font
                End With
            End With
            With .YAxis(7)
                With .Grid
                    .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                    .LineColor = Color.Maroon
                End With
                With .Scale
                    .ScaleType = XYChartNet.XYChartNETCtl.ScaleTypes.stLinear
                    .Visible = True
                    .Position = XYChartNet.XYChartNETCtl.ScalePositionOptions.spLeftOrBottom
                    .LabelVertical = "Y7Description"
                    .LabelVerticalFont = my8Font
                    .LabelVerticalColor = Color.Green
                    .Label = "Y7Units"
                    .LabelFont = my8Font
                    .LabelColor = Color.Green
                    .TicksColor = Color.Green
                    .TicksFont = my10Font
                End With
            End With
            With .YAxis(8)
                With .Grid
                    .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                    .LineColor = Color.Maroon
                End With
                With .Scale
                    .ScaleType = XYChartNet.XYChartNETCtl.ScaleTypes.stLinear
                    .Visible = True
                    .Position = XYChartNet.XYChartNETCtl.ScalePositionOptions.spLeftOrBottom
                    .LabelVertical = "Y8Description"
                    .LabelVerticalFont = my8Font
                    .LabelVerticalColor = Color.Green
                    .Label = "Y8Units"
                    .LabelFont = my8Font
                    .LabelColor = Color.Green
                    .TicksColor = Color.Green
                    .TicksFont = my10Font
                End With
            End With
            With .YAxis(9)
                With .Grid
                    .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                    .LineColor = Color.Maroon
                End With
                With .Scale
                    .ScaleType = XYChartNet.XYChartNETCtl.ScaleTypes.stLog
                    .Visible = True
                    .Position = XYChartNet.XYChartNETCtl.ScalePositionOptions.spRightOrTop
                    .LabelVertical = "Y9Description"
                    .LabelVerticalFont = my8Font
                    .LabelVerticalColor = Color.Maroon
                    .Label = "Y9Units"
                    .LabelFont = my8Font
                    .LabelColor = Color.Maroon
                    .TicksColor = Color.Maroon
                    .TicksFont = my10Font
                End With
            End With

            ' Profiles
            ' Format Profile 0
            With .Profile(0)
                .XScale = 0
                .YScale = 0
                .Label = "Profile 0"
                .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                .LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woTwoPoint
                .LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid
                .LineColor = Color.Green
                .MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone
                .NumSamples = NUM_SAMPLES
            End With

            ' Format Profile 1
            With .Profile(1)
                .XScale = 0
                .YScale = 1
                .Label = "Profile 1"
                .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                .LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woTwoPoint
                .LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid
                .LineColor = Color.Maroon
                .MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone
                .NumSamples = NUM_SAMPLES
            End With

            ' Format Profile 2
            With .Profile(2)
                .XScale = 0
                .YScale = 2
                .Label = "Profile 2"
                .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                .LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woTwoPoint
                .LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid
                .LineColor = Color.Green
                .MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone
                .NumSamples = NUM_SAMPLES
            End With

            ' Format Profile 3
            With .Profile(3)
                .XScale = 0
                .YScale = 3
                .Label = "Profile 3"
                .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                .LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woTwoPoint
                .LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid
                .LineColor = Color.Maroon
                .MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone
                .NumSamples = NUM_SAMPLES
            End With

            ' Format Profile 4
            With .Profile(4)
                .XScale = 0
                .YScale = 4
                .Label = "Profile 4"
                .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                .LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woTwoPoint
                .LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid
                .LineColor = Color.Green
                .MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone
                .NumSamples = NUM_SAMPLES
            End With

            ' Format Profile 5
            With .Profile(5)
                .XScale = 0
                .YScale = 5
                .Label = "Profile 5"
                .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                .LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woTwoPoint
                .LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid
                .LineColor = Color.Maroon
                .MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone
                .NumSamples = NUM_SAMPLES
            End With

            ' Format Profile 6
            With .Profile(6)
                .XScale = 0
                .YScale = 6
                .Label = "Profile 6"
                .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                .LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woTwoPoint
                .LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid
                .LineColor = Color.Maroon
                .MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone
                .NumSamples = NUM_SAMPLES
            End With

            ' Format Profile 7
            With .Profile(7)
                .XScale = 0
                .YScale = 7
                .Label = "Profile 7"
                .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                .LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woTwoPoint
                .LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid
                .LineColor = Color.Green
                .MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone
                .NumSamples = NUM_SAMPLES
            End With

            ' Format Profile 8
            With .Profile(8)
                .XScale = 0
                .YScale = 8
                .Label = "Profile 8"
                .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                .LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woTwoPoint
                .LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid
                .LineColor = Color.Green
                .MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone
                .NumSamples = NUM_SAMPLES
            End With

            ' Format Profile 9
            With .Profile(9)
                .XScale = 0
                .YScale = 9
                .Label = "Profile 9"
                .LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom
                .LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woTwoPoint
                .LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid
                .LineColor = Color.Maroon
                .MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone
                .NumSamples = NUM_SAMPLES
            End With

            ' Create random chart data, then feed into XYChartNET
            Dim iSample As Integer
            Dim iProfile As Integer
            Dim ChartData(,) As Double
            ReDim ChartData(.Profile(0).NumSamples - 1, 2 * .NumProfiles - 1)
            For iProfile = 0 To .NumProfiles - 1
                For iSample = 0 To .Profile(0).NumSamples - 1
                    ChartData(iSample, iProfile * 2) = iSample * 1
                    ChartData(iSample, iProfile * 2 + 1) = 999 * Rnd() + 1
                Next iSample
            Next iProfile
            .ChartData = ChartData

            .Refresh()
        End With
    End Sub

    Private Sub XyChartNETCtl1_PlotDoubleClick(ByVal Index As Integer, ByVal xPos As Integer, ByVal yPos As Integer)
        XyChartNETCtl1.SetZoomOutAll()
    End Sub
End Class
